<%pageContext.setAttribute("path","../");%>
<%@ include file="../menu.jsp" %>
<%@ page import="org.apache.taglibs.standard.tag.common.sql.ResultImpl" %>
<fmt:bundle basename="campaigns">
	<div id="right">
		<c:if test="${not empty sessionScope.message}">
			<c:set var="class" value="error"/>
			<c:if test="${sessionScope.messageType eq \"error\"}">
				<c:set var="class" value="error"/>
			</c:if>
			<c:if test="${sessionScope.messageType eq \"ok\"}">
				<c:set var="class" value="ok"/>
			</c:if>
			<div class="${class}">
				<c:set var="class" value=""/>
				${sessionScope.message}
				<c:set var="message" value="" scope="session"/>
			</div>
		</c:if>
		<c:choose>
			<c:when test="${not empty param.id}">
				<h2><fmt:message key="addcampaign.stats" /></h2>
				 
				 <sql:query var="rs" dataSource="jdbc/callcenter">
					SELECT 
						COUNT(ex.id) AS count, 
						SUM(IF(num_llamadas > 0, 1, 0)) AS llamados, 
						SUM(IF(num_llamadas = 0, 1, 0)) AS sin_llamar, 
						SUM(IF(llamar = 0 OR num_llamadas >= max_retries, 1, 0)) AS terminados,
						SUM(IF(fecha_actualizado > NOW() - INTERVAL 5 MINUTE, 1, 0)) AS ultimos5,
						SUM(IF(llamar = 1 AND num_llamadas < max_retries AND (
							(NOT EXISTS (SELECT * FROM llamadas WHERE id_cliente = c.id AND id_campania = c.id)) OR
							((SELECT max(fecha) FROM llamadas WHERE id_cliente = ex.id AND id_campania = c.id) + INTERVAL retry_time MINUTE < NOW())),
						1,0)) AS disponibles
					FROM campanias c					
					LEFT JOIN clientes_extrainfo ex ON ex.id_campania = c.id 
					WHERE c.id = ${param.id}
				</sql:query> 
				 
				<table class="data">	
					<tr class="tit">
						<th><fmt:message key="addcampaigns.loaded" /></th>
						<th><fmt:message key="addcampaigns.called" /></th>
						<th><fmt:message key="addcampaigns.nocalled" /></th>
						<th><fmt:message key="addcampaigns.terminated" /></th>
						<th><fmt:message key="addcampaigns.available" /></th>
						<th><fmt:message key="addcampaigns.lastfive" /></th>
					</tr>
					<tr class="odd">
						<td class="data">${rs.rows[0].count}</td>
						<td class="data">${rs.rows[0].llamados}</td>
						<td class="data">${rs.rows[0].sin_llamar}</td>
						<td class="data">${rs.rows[0].terminados}</td>
						<td class="data">${rs.rows[0].disponibles}</td>
						<td class="data">${rs.rows[0].ultimos5}</td>
					</tr>
				</table>
				   
				<h2><fmt:message key="addcampaign.config" /></h2>
			</c:when>
			<c:otherwise>
				<h2><fmt:message key="addcampaign.edit" />:</h2>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${(empty param.morning)}">		
				
				<sql:query var="rsTime" dataSource="jdbc/ipcontact">
					SELECT *
					FROM time_range
				</sql:query>
				
				<sql:query var="rsPrefix" dataSource="jdbc/callcenter">
					SELECT *
					FROM prefijos
				</sql:query>
			
				<c:choose>
					<c:when test="${not empty param.id}">
						<sql:query var="rsCamp" dataSource="jdbc/callcenter">
							SELECT * 
							FROM campanias
							WHERE id = '${param.id}'
						</sql:query>
						
						<sql:query var="rsOut" dataSource="jdbc/ipcontact">
							SELECT * 
							FROM outgoing_profile
							WHERE id = '${param.id}'
						</sql:query>
						
						<c:set var="name" value="${rsCamp.rows[0].info}"/>   
						<c:set var="enabled" value="${rsOut.rows[0].active}"/>
						<c:set var="popup" value="${rsOut.rows[0].url}"/>
						<c:set var="morning" value="${rsOut.rows[0].morning}"/>
						<c:set var="evening" value="${rsOut.rows[0].evening}"/>
						<c:set var="weekend" value="${rsOut.rows[0].weekend}"/>
						<c:set var="dedicated" value="${rsOut.rows[0].dedicated_agents}"/>
						<c:set var="prefix" value="${rsOut.rows[0].prefix}"/>
						<c:set var="maxRetries" value="${rsCamp.rows[0].max_retries}"/>
						<c:set var="retryTime" value="${rsCamp.rows[0].retry_time}"/>
						<c:set var="scheduleTime" value="${rsOut.rows[0].schedule_time}"/>
						<c:if test="${sessionScope.predictiveEnabled}">
							<c:set var="oldName" value="${rsCamp.rows[0].info}"/> 
							<c:set var="predictive" value="${rsOut.rows[0].predictive}"/>
							<c:set var="oldPredictive" value="${rsOut.rows[0].predictive}"/>
							<c:set var="timeCalls" value="${rsOut.rows[0].time_between_calls}"/>
							<c:set var="maxQueueSize" value="${rsOut.rows[0].predictive_max_queue_size}"/>
							<c:set var="welcomeMessage" value="${rsOut.rows[0].welcome_message}"/>
						</c:if>
					</c:when>
					
					<c:otherwise>
						<c:set var="name" value=""/>
						<c:set var="oldName" value=""/> 
						<c:set var="enabled" value="true"/>
						<c:set var="popup" value=""/>
						<c:set var="morning" value=""/>
						<c:set var="evening" value=""/>
						<c:set var="weekend" value=""/>
						<c:set var="dedicated" value="true"/>
						<c:set var="prefix" value=""/>
						<c:set var="maxRetries" value="3"/>
						<c:set var="retryTime" value="30"/>
						<c:set var="scheduleTime" value="15"/>
						<c:if test="${sessionScope.predictiveEnabled}">
							<c:set var="oldName" value=""/> 
							<c:set var="predictive" value=""/>
							<c:set var="oldPredictive" value=""/>
							<c:set var="timeCalls" value=""/>
							<c:set var="maxQueueSize" value=""/>
							<c:set var="welcomeMessage" value=""/>
						</c:if>
					</c:otherwise>
				</c:choose>
				
				<form onsubmit="return validateOnSubmit()" method="post" action="addCampaign.jsp" name="formulario">
					<table class="query">
						<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.name" /></td>
							<td class="query">       				
							    <input type="text" name="name" size="20" maxlength="128" value="${name}" onchange="validatePresent(this, 'inf_name');"/>
							</td>
							<td class="query" id="inf_name"><c:if test="${empty name}"><fmt:message key="required" /></c:if></td>
				   		</tr>
				   		
						<sql:query var="rs2" dataSource="jdbc/callcenter">
							SELECT form
							FROM forms_metadata
							GROUP BY form
						</sql:query>
		
						<c:if test="${empty param.id}">
							<tr class="plain">
							    <td class="query"><fmt:message key="addcampaign.form" /></td>
							    <td class="query">       				
								<select name="form">
									<option value=""><fmt:message key="none" /></option>
									<c:forEach var="row" varStatus="stat" items="${rs2.rows}">
										<option value="${row.form}">${row.form}</option>
									</c:forEach>
								</select> 
							    </td>
							    <td class="query" id="inf_name"/>
					   		</tr>
				   		</c:if>
				   		
				   		<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.prefix" /></td>
							<td class="query">       				
								<select name="prefix">
									<option value=""><fmt:message key="none" /></option>
									<c:forEach var="row" items="${rsPrefix.rows}">
										<c:if test="${row.prefijo eq prefix}">
											<c:set var="selected" value="selected=\"selected\""/>
										</c:if>
										<option value="${row.prefijo}" ${selected}>${row.nombre}</option>
										<c:set var="selected" value=""/>
									</c:forEach>
								</select> 
							</td>
							<td class="query"></td>
				   		</tr>
				   		
						<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.url" /></td>
							<td class="query">       				
							    <input type="text" name="popup" size="50" maxlength="100" value="${popup}" onchange="validatePresent(this, 'inf_popup');"/>
							</td>
							<td class="query" id="inf_popup"><c:if test="${empty popup}"><fmt:message key="required" /></c:if></td>
				   		</tr>
				   		
						<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.morning" /></td>
							<td class="query">       				
								<select name="morning">
									<c:forEach var="row" items="${rsTime.rows}">
										<c:if test="${row.id eq morning}">
											<c:set var="selected" value="selected=\"selected\""/>
										</c:if>
										<option value="${row.id}" ${selected}>${row.begin} - ${row.end}</option>
										<c:set var="selected" value=""/>
									</c:forEach>
								</select> 
							</td>
							<td class="query"></td>
				   		</tr>
						
						<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.evening" /></td>
							<td class="query">       				
								<select name="evening">
									<c:forEach var="row" items="${rsTime.rows}">
										<c:if test="${row.id eq evening}">
											<c:set var="selected" value="selected=\"selected\""/>
										</c:if>
										<option value="${row.id}" ${selected}>${row.begin} - ${row.end}</option>
										<c:set var="selected" value=""/>
									</c:forEach>
								</select> 
							</td>
							<td class="query"></td>
				   		</tr>
					
						<tr class="plain">
				   			<td class="query"><fmt:message key="addcampaign.weekend" /></td>
							<td class="query">       				
								<select name="weekend">
									<c:forEach var="row" items="${rsTime.rows}">
										<c:if test="${row.id eq weekend}">
											<c:set var="selected" value="selected=\"selected\""/>
										</c:if>
										<option value="${row.id}" ${selected}>${row.begin} - ${row.end}</option>
										<c:set var="selected" value=""/>
									</c:forEach>
								</select> 
							</td>
							<td class="query"></td>
				   		</tr>

						<tr class="plain">
							<td class="query"><fmt:message key="addcampaign.maxRetries"/></td>
							<td class="query">       				
							    <input type="text" name="maxRetries" size="5" value="${maxRetries}" onchange="validateNr(this, 'inf_maxRetries', true);"/>
							</td>
							<td class="query" id="inf_maxRetries"></td>
						</tr>

						<tr class="plain">
							<td class="query"><fmt:message key="addcampaign.retryTime"/></td>
							<td class="query">       				
							    <input type="text" name="retryTime" size="5" value="${retryTime}" onchange="validateNr(this, 'inf_retryTime', true);"/>
							</td>
							<td class="query" id="inf_retryTime"></td>
						</tr>

						<tr class="plain">
							<td class="query"><fmt:message key="addcampaign.scheduleTime"/></td>
							<td class="query">       				
							    <input type="text" name="scheduleTime" size="5" value="${scheduleTime}" onchange="validateNr(this, 'inf_scheduleTime', true);"/>
							</td>
							<td class="query" id="inf_scheduleTime"></td>
						</tr>
		
						<tr class="plain">
							<td class="query"><fmt:message key="addcampaign.enabled" /></td>
							<td class="query">
								<c:if test="${enabled}">
									<c:set var="checked" value="checked=\"checked\""/>
								</c:if>
								<input type="checkbox" name="enabled" ${checked}/>
								<c:set var="checked" value=""/>
							</td>
							<td class="query"/>
						</tr>
						
						<tr class="plain">
							<td class="query"><fmt:message key="addcampaign.dedicated" /></td>
							<td class="query">
								<c:if test="${dedicated}">
									<c:set var="checked" value="checked=\"checked\""/>
								</c:if>
								<input type="checkbox" name="dedicated" ${checked}/>
								<c:set var="checked" value=""/>
							</td>
							<td class="query"/>
						</tr>
						
						<c:if test="${sessionScope.predictiveEnabled}">
							<tr class="plain">
								<td class="query"><fmt:message key="addcampaign.predictive" /></td>
								<td class="query">
									<c:if test="${predictive}">
										<c:set var="checked" value="checked=\"checked\""/>
									</c:if>
									<input type="checkbox" name="predictive" ${checked}/>
									<c:set var="checked" value=""/>
								</td>
								<td class="query"/>
							</tr>
							
							<tr class="plain">
					   			<td class="query"><fmt:message key="addcampaign.timeBetweenCalls"/></td>
								<td class="query">       				
								    <input type="text" name="timeCalls" size="5" value="${timeCalls}" onchange="validateNr(this, 'inf_calls', false);"/>
								</td>
								<td class="query" id="inf_calls"><fmt:message key="addcampaign.predictiveOnly"/></td>
				   			</tr>

							<tr class="plain">
					   			<td class="query"><fmt:message key="addcampaign.maxQueueSize"/></td>
								<td class="query">       				
								    <input type="text" name="maxQueueSize" size="5" value="${maxQueueSize}" onchange="validateNr(this, 'inf_maxQueueSize', false);"/>
								</td>
								<td class="query" id="inf_maxQueueSize"><fmt:message key="addcampaign.predictiveOnly"/></td>
				   			</tr>

							<tr class="plain">
					   			<td class="query"><fmt:message key="addcampaign.welcomeMessage"/></td>
								<td class="query">       				
								    <input type="text" name="welcomeMessage" size="20" maxlength="128" value="${welcomeMessage}"/>
								</td>
								<td class="query"><fmt:message key="addcampaign.predictiveOnly"/></td>
				   			</tr>
						</c:if>
					</table>
					
					<c:if test="${not empty param.id}">
						<h2><fmt:message key="addcampaign.fields" /></h2>
						
						<sql:query var="rs" dataSource="jdbc/callcenter">
							SELECT * FROM campaign_forms_metadata
							WHERE campaign = ${param.id}
							ORDER BY orden
						</sql:query>
		
						<c:choose>
							<c:when test="${not empty rs.rows}">
								<table class="data">	
									<tr class="tit">
										<th><fmt:message key="addcampaign.field" /></th>
										<th><fmt:message key="addcampaign.value" /></th>
										<th><fmt:message key="addcampaign.length" /></th>
										<th><fmt:message key="addcampaign.options" /></th>
									</tr>
						
									<c:forEach var="row" varStatus="stat" items="${rs.rows}">
										<c:choose>
											<c:when test="${stat.count % 2 == 0}">
												<tr class="even">
											</c:when>
											<c:otherwise>
												<tr class="odd">
											</c:otherwise>
										</c:choose>	
										<td class="data">${row.campo}</td>
										<td class="data">${row.valor}</td>
										<td class="data">${row.largo}</td>
										<td class="data">
											${row.opciones}
											<c:if test="${empty row.opciones}">
												<fmt:message key="none" />
											</c:if>
										</td>
									</tr>
									</c:forEach>
								</table>
							</c:when>
							<c:otherwise>
								<p><fmt:message key="addcampaign.empty" /></p>
							</c:otherwise>
						</c:choose>
					</c:if>
			
					<input type="hidden" name="fieldSize"/>
					<input type="hidden" name="id" value="${param.id}"/>
					<input type="hidden" name="fieldSize2" value="${fieldSize}"/>

					<c:if test="${sessionScope.predictiveEnabled}">
					    <input type="hidden" name="oldName" value="${oldName}"/>
					    <input type="hidden" name="oldPredictive" value="${oldPredictive}"/>
					</c:if>

					<br/>
					<br/>
					<c:choose>
						<c:when test="${empty param.id}">
							<table class="query">
								<tr class="plain">
									<td class="query">
										<fmt:message key="submit" var="submit"/>
										<input class="boton" type="submit" value="${submit}" align="middle"/> 
										<c:set var="submit" value=""/>
									</td>
									<td class="query" colspan="3">
										<fmt:message key="reset" var="reset"/>
										<input class="boton" type="reset" value="${reset}" align="middle"/>
										<c:set var="reset" value=""/>
									</td>
								</tr>
							</table>	
						</c:when>
						<c:otherwise>
							<table class="query">
								<tr class="plain">
									<td class="query">
										<fmt:message key="save" var="save"/>
										<input class="boton" type="submit" value="${save}" align="middle"/>
										<c:set var="save" value=""/>
									</td>
									<td class="query" colspan="3">
										<fmt:message key="reset" var="reset"/>
										<input class="boton" type="reset" value="${reset}" align="middle"/>
										<c:set var="reset" value=""/>
									</td>
								</tr>
							</table>	
						</c:otherwise>
					</c:choose>
				</form>
			</c:when>
			
			<c:otherwise>
				<jsp:useBean id="camp" class="ipcontact.campaigns.AddCampaign" scope="page">
					<c:choose>
						<c:when test="${not empty param.id}">
							<c:set target="${camp}" property="id" value="${param.id}"/>
						</c:when>
						<c:otherwise>
							<c:set target="${camp}" property="id" value="-1"/>
						</c:otherwise>
					</c:choose>
					<c:set target="${camp}" property="name" value="${param.name}"/>
					<c:set target="${camp}" property="form" value="${param.form}"/>
					<c:set target="${camp}" property="popup" value="${param.popup}"/>
					<c:set target="${camp}" property="morning" value="${param.morning}"/>
					<c:set target="${camp}" property="evening" value="${param.evening}"/>
					<c:set target="${camp}" property="weekend" value="${param.weekend}"/>
					<c:set target="${camp}" property="enabled" value="${param.enabled}"/>
					<c:set target="${camp}" property="dedicated" value="${param.dedicated}"/>
					<c:set target="${camp}" property="prefix" value="${param.prefix}"/>
					<c:set target="${camp}" property="maxRetries" value="${param.maxRetries}"/>
					<c:set target="${camp}" property="retryTime" value="${param.retryTime}"/>
					<c:set target="${camp}" property="scheduleTime" value="${param.scheduleTime}"/>
					<c:set target="${camp}" property="network" value="${sessionScope.connection}"/>
					<c:if test="${sessionScope.predictiveEnabled}">
						<c:set target="${camp}" property="predictive" value="${param.predictive}"/>
						<c:set target="${camp}" property="timeBetweenCalls" value="${param.timeCalls}"/>
						<c:set target="${camp}" property="oldName" value="${param.oldName}"/>
						<c:set target="${camp}" property="oldPredictive" value="${param.oldPredictive}"/>
						<c:set target="${camp}" property="maxQueueSize" value="${param.maxQueueSize}"/>
						<c:set target="${camp}" property="welcomeMessage" value="${param.welcomeMessage}"/>
					</c:if>
				</jsp:useBean>
				
				<c:set var="result" value="${camp.result}"/>
				
				<c:choose>
					<c:when test="${result eq \"updated\"}">
						<fmt:message key="addcampaign.updated" var="message">
							<fmt:param value="${param.name}"/>
						</fmt:message>
						<c:set var="message" value="${message}" scope="session"/>
						<c:set var="messageType" value="ok" scope="session"/>
					</c:when>
					<c:when test="${result eq \"added\"}">
						<fmt:message key="addcampaign.added" var="message">
							<fmt:param value="${param.name}"/>
						</fmt:message>
						<c:set var="message" value="${message}" scope="session"/>
						<c:set var="messageType" value="ok" scope="session"/>
					</c:when>
					<c:otherwise>
						<c:set var="message" value="${result}" scope="session"/>			
						<c:set var="messageType" value="error" scope="session"/>
					</c:otherwise>
				</c:choose>
				<c:redirect url="addCampaign.jsp?id=${param.id}"/>
			</c:otherwise>
		</c:choose>
	</div>
</fmt:bundle>
</html>