<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="/WEB-INF/query.tld" prefix="w" %>
<%@ page contentType="text/csv; charset=iso-8859-1" %>
<%@ page import="java.sql.Connection" %>
<%@ page import="java.sql.Statement" %>
<%@ page import="java.sql.ResultSet" %>
<%@ page import="java.sql.SQLException" %>
<%@ page import="javax.servlet.jsp.jstl.fmt.LocaleSupport" %>
<%@ page import="javax.naming.Context" %>
<%@ page import="javax.naming.InitialContext" %>
<%@ page import="javax.naming.NamingException" %>
<%@ page import="javax.sql.DataSource" %>
<fmt:bundle basename="results">
<w:where var="conds">
	<w:condition attribute="fecha" afterDate="${param.afterDate}" afterTime="${param.afterTime}"/>
	<w:condition attribute="fecha" beforeDate="${param.beforeDate}" beforeTime="${param.beforeTime}"/>
	<c:if test="${param.agent != \"all\"}">
		<w:condition attribute="agente" value="${param.agent}"/>
	</c:if>
	<c:if test="${param.campaign != \"all\"}">
		<w:condition attribute="id_campania" value="${param.campaign}"/>
	</c:if>
	<c:if test="${param.result != \"all\"}">
		<w:condition attribute="resultado" value="${param.result}"/>
	</c:if>
	<c:if test="${sessionScope.role ne 'admin'}">
	    <w:condition condition="user_id = '${sessionScope.username}'"/>    
	</c:if>
</w:where>
<fmt:message key="calldata.id" var="id"/>
<fmt:message key="calldata.firstname" var="firstname"/>
<fmt:message key="calldata.lastname" var="lastname"/>
<fmt:message key="calldata.address" var="address"/>
<fmt:message key="calldata.phone" var="phone"/>
<fmt:message key="calldata.email" var="email"/>
<fmt:message key="calldata.date" var="date"/>
<fmt:message key="calldata.campaign" var="campaign"/>
<fmt:message key="calldata.result" var="result"/>
<fmt:message key="calldata.newphone" var="newphone"/>
<fmt:message key="calldata.notes" var="notes"/>
<fmt:message key="calldata.agent" var="agent"/>	
</fmt:bundle>
<%
		Context environment;
		DataSource pool;
		Connection connection = null, connection2 = null;
		Statement statement = null, statement2 = null;
		ResultSet rs = null, rs2 = null;
		Object data;
		Object [] queryData = new Object [14];
		String sep = session.getAttribute("csvSeparator").toString();
		String ipcontactTable = session.getAttribute("ipcontactTable").toString();
		String role = session.getAttribute("role").toString();
			
		response.setHeader("Content-Disposition", "attachment; filename=\"llamadas.csv\"");
		try {
			String conds2 = pageContext.getAttribute("conds").toString();
			
			environment = new InitialContext();
			pool = (DataSource)environment.lookup("java:comp/env/jdbc/callcenter");
			connection = pool.getConnection();
			connection2 = pool.getConnection();
			statement = connection.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_READ_ONLY); 
			statement.setFetchSize(Integer.MIN_VALUE); 
			statement2 = connection2.createStatement();
			
			String sql;
			
			if (role.equals("admin")) {
			    sql =
				"SELECT a.id AS cid, c.id AS id, nombre, apellido, direccion, telefono, email, DATE_FORMAT(fecha, '%d/%m/%Y %T') AS fechaf, " +
					"info, valor, nuevo_tel, notas, CONCAT(first_name, last_name), m.id AS uid " +
				"FROM llamadas m " +
				"INNER JOIN clientes c on id_cliente  = c.id " +
				"INNER JOIN campanias a on id_campania = a.id " +
				"INNER JOIN llamadas_resultados l on resultado = l.id " +
				"LEFT JOIN " + ipcontactTable + ".users on username = agente " +
				conds2 + " ORDER BY id_campania, fecha"; 
			}
			else {
			    sql =
				"SELECT c.id AS id, nombre, apellido, direccion, telefono, email, info, filename, m.id AS uid, a.id AS cid, " +
					"DATE_FORMAT(fecha, '%d/%m/%Y %T') AS fechaf, valor, nuevo_tel, notas, first_name, last_name " +
				"FROM llamadas m " +
				"INNER JOIN clientes c on id_cliente  = c.id " +
				"INNER JOIN campanias a on id_campania = a.id " +
				"INNER JOIN llamadas_resultados l on resultado = l.id " +
				"INNER JOIN " + ipcontactTable + ".users on username = agente " +
				"INNER JOIN " + ipcontactTable + ".supervisors_groups USING (group_id) " +
				"LEFT JOIN " + ipcontactTable + ".callmonitor on uniqueid = m.id " +
				conds2 +  
				" ORDER BY id_campania, fecha ";			
			}
	
			System.out.println("SQL: " + sql);
			rs = statement.executeQuery(sql);
			
			String select = "", lastCampaign = null;
			int fieldCount = 0;
			
			while (rs.next()) {
				for (int i=0; i<queryData.length; i++) {
					queryData[i] = rs.getObject(i+1);
				}
				if (!queryData[0].toString().equals(lastCampaign)) {
					lastCampaign = queryData[0].toString();
					out.print(pageContext.getAttribute("id") + 
						sep + pageContext.getAttribute("firstname") + 
						sep + pageContext.getAttribute("lastname") + 
						sep + pageContext.getAttribute("address") + 
						sep + pageContext.getAttribute("phone") + 
						sep + pageContext.getAttribute("email") + 
						sep + pageContext.getAttribute("date") + 
						sep + pageContext.getAttribute("campaign") + 
						sep + pageContext.getAttribute("result") + 
						sep + pageContext.getAttribute("newphone") + 
						sep + pageContext.getAttribute("notes") + 
						sep + pageContext.getAttribute("agent") + sep);
				
					sql = 
						"SELECT campo " + 
						"FROM campaign_forms_metadata " +
						"WHERE campaign = '" + lastCampaign + "' ORDER BY orden";
						
					System.out.println("SQL: " + sql);
					rs2 = statement2.executeQuery(sql);
					
					select = "";
					fieldCount = 0;
					while (rs2.next()) {
						out.print(rs2.getString(1) + sep);
						select += rs2.getString(1) + ", ";
					}
					out.println();
					if (select.length() > 0) {
						select = select.substring(0, select.length() - 2); // saco la ultima , y espacio
					}
					
					sql = 
						"SELECT count(*) " + 
						"FROM campaign_forms_metadata " +
						"WHERE campaign = '" + lastCampaign + "' ORDER BY orden";
						
					System.out.println("SQL: " + sql);
					rs2 = statement2.executeQuery(sql);
					if (rs2.next()) {
						fieldCount = rs2.getInt(1);
					}
				}
				
				for (int i=1; i<=12; i++) {
					out.print((queryData[i] == null ? "" : queryData[i]) + sep);
				}
				
				if (select.length() > 0) {
					sql = 
						"SELECT " + select + " " +
						"FROM datos" + lastCampaign + " " +
						"WHERE id = '" + queryData[13] + "'";
						
					System.out.println("SQL: " + sql);
					rs2 = statement2.executeQuery(sql);
					
					while (rs2.next()) {
						for (int i=1; i<=fieldCount; i++) {
							data = (rs2.getObject(i));
							out.print((data == null ? "" : data) + sep);
						}
					}
				}
						
				out.println();
			}
		}
		catch (NamingException e) {
			e.printStackTrace();
		} 
		catch (SQLException e) {
			e.printStackTrace();
		} 
		finally {
			try {
				if (rs != null) rs.close();
				if (rs2 != null) rs2.close();
			}
		  	catch (SQLException e) {};
		  	
		  	try {
		  		if (statement != null) statement.close();
		  		if (statement2 != null) statement2.close();
		  	}
		  	catch (SQLException e) {}
		  			
		  	try {
		  		if (connection != null) connection.close();
		  		if (connection2 != null) connection2.close();
		  	}
		  	catch (SQLException e) {}
		}
%>